* Rotclock V0.9 QRT 211197
*
* qrt@qland.de

* 8051 Assembler bit-assignments
* PSW
CY      BIT     $D7
AC      BIT     $D6
F0      BIT     $D5
RS1     BIT     $D4
RS0     BIT     $D3
OV      BIT     $D2
P       BIT     $D0
* TCON
TF1     BIT     $8F
TR1     BIT     $8E
TF0     BIT     $8D
TR0     BIT     $8C
IE1     BIT     $8B
IT1     BIT     $8A
IE0     BIT     $89
IT0     BIT     $88
* T2CON
TR2     BIT     $CA
TF2     BIT     $CF
* IE 
EA      BIT     $AF
ES      BIT     $AC
ET1     BIT     $AB
EX1     BIT     $AA
ET0     BIT     $A9
EX0     BIT     $A8
ET2     BIT     $AD
* IP 
PS      BIT     $BC
PT1     BIT     $BB
PX1     BIT     $BA
PT0     BIT     $B9
PX0     BIT     $B8
PT2     BIT     $BD
* P3
RD      BIT     $B7
WR      BIT     $B6
T1      BIT     $B5
T0      BIT     $B4
INT1    BIT     $B3
INT0    BIT     $B2
TXD     BIT     $B1
RXD     BIT     $B0
* SCON
SM0     BIT     $9F
SM1     BIT     $9E
SM2     BIT     $9D
REN     BIT     $9C
TB8     BIT     $9B
RB8     BIT     $9A
TI      BIT     $99
RI      BIT     $98

        ORG     $0000           ROM Starts here
        LJMP    main
        ORG     $0003
        LJMP    Ext0Int         
        ORG     $000b
        LJMP    Timer0Int       
*        ORG     $0013
*        LJMP    Ext1Int        
        ORG     $001b
        LJMP    Timer1Int       
*        ORG     $0023
*        LJMP    SerInt          
*        ORG     $002b
*        LJMP    Timer2Int       
        
?R0     EQU     0           
?R1     EQU     ?R0+1         
?R2     EQU     ?R0+2       
?R3     EQU     ?R0+3          
?R4     EQU     ?R0+4
?R5     EQU     ?R0+5
?R6     EQU     ?R0+6
?R7     EQU     ?R0+7

dz1		DATA		$08
rpl		DATA		$09			round period low
rph		DATA		$0a			round period high
ovc1		DATA		$0b			overflowcounter 1
lcl		DATA		$0c			LED-counter low
lch		DATA		$0d			LED-counter high
lcresetl	DATA		$0e			LED-counter-reset low
lcreseth	DATA		$0f			LED-counter-reset high

flbyte1	DATA		$20			flagbyte 1
ledoti	BIT		$00			LED-on-time
rcreq	BIT		$01			round-calc-request
rcact	BIT		$02			round-calc-active
lstart	BIT		$03			LED-Start
tsync	BIT		$04			Timer-Sync or IR-Sync
dosup	BIT		$05

DATA1	EQU		$21			$21 - $44 36 bit
stack	DATA		$60

MAXD1	EQU		36			number of data1
BAREL	EQU		-24			Baudrate reload 2400 BAUD
*							11,05920 MHz, no predivision
*							(1200) -48 11,05920 MHz, no predivision
*							(1200) -52 12 MHz, no predivision

DETECT	EQU		INT0    
LEDOUT	EQU		P1

LCSTOP	EQU		MAXD1*2*3		LED ON/OFF cycles till counter stop
LCROND	EQU		MAXD1*2*4		LED ON/OFF cycles per round

C_COMB	EQU		$a5
C_FILLA	EQU		$51
C_RCHK	EQU		$52
C_DELAY	EQU		$53


main
		mov		A,#40
?wa4		mov		R1,#0		
?wa3		mov		R0,#0		
		djnz		R0,*
		djnz		R1,?wa3
		djnz		A,?wa4

		mov		IE,#0        	all IR's disable and delete
   		mov		SP,#(stack-1) 	stack init

		acall	maininit
		acall	filldat
		setb		EA			all IR's enable

		acall	crchk		round-calc

		mov		A,#20
		acall	wait

		acall	crchk		round-calc

?mad0	acall	getb
		cjne		A,#C_COMB,?mad0	commandbyte?

		acall	getb
		cjne		A,#C_FILLA,?mad1
		acall	cfilla
		sjmp		?mad0

?mad1	cjne		A,#C_RCHK,?mad2
		acall	crchk
		sjmp		?mad0

?mad2	cjne		A,#C_DELAY,?mad3
		acall	cdelay
		sjmp		?mad0

?mad3	sjmp		?mad0

*************************************************************************

maininit

* Timer0 for rotation-bit-control
		anl		TMOD,#$f0     T0 vorbereiten ohne T1 zu verndern
        	orl		TMOD,#$01     Gate0=0, c/t0=0, Mode1=01 16-bit
        	setb		PT0          	Timer0 Prioritt
*		mov		rpl,#-250		first LED on-time 
*		mov		rph,#=(-250)

* INT0 for rotation-start-control
		setb		PX0			INT0 Prioritt				
		setb		IT0			INT0 edge trigger

* INT1 not in use
*		clr		PX1			INT1 Prioritt
*		setb		IT1			INT1	edge trigger

		setb		EX0			INT0-IR enable
*		setb		EX1			INT1-IR enable
        	setb		ET0         	T0-IR enable
*		setb		ET1			T1-IR enable
					
		mov		flbyte1,#0	reset flags to zero
		mov		dz1,#DATA1	init variables
		ret

*************************************************************************

filldat
		mov		A,#$55
		mov		R0,#DATA1		fill Data1 with 
?ma3		mov		[R0],A		testpattern in A
		cpl		A
		inc		R0
		cjne		R0,#DATA1+MAXD1,?ma3
		ret

*************************************************************************

wait
?wa2		mov		R1,#0		is coming up
?wa1		mov		R0,#0		
		djnz		R0,*
		djnz		R1,?wa1
		djnz		A,?wa2
		ret

*************************************************************************

getb		jnb		RI,*
		mov		A,SBUF
		clr		RI
		ret	

*************************************************************************

cfilla
		mov		R0,#DATA1		fill all DATA1-ram
?cfa1	jnb		RI,*
		mov		[R0],SBUF
		clr		RI
		inc		R0
		cjne		R0,#DATA1+MAXD1,?cfa1
		ret

*************************************************************************

cdelay
		acall	getb			get databyte	

		jnz		?cdl1		=0?
		clr		tsync		yes, now IR-sync
		ret

?cdl1	mov		B,#0			no databyte<>0, B preset 0 for data>0
		jnb		A.7,?cdl2		databyte < 0?
		mov		B,#$ff		yes, B preset $ff for data <0
?cdl2	add		A,#LCROND		databyte + LCROND (LB)
		mov		lcresetl,A	store in lcreset
		xch		A,B			B preset to A
		addc		A,#=LCROND	preset + lcreset (HB)
		mov		lcreseth,A	store in lcreset
		setb		tsync		now timer-sync
		setb		TR0			start T0 (if double suppress is on)
		ret

*************************************************************************

crchk
		clr		TR1			stop Timer1
		anl		TMOD,#$0f		prepare T1 without changing T0 
		orl		TMOD,#$10		Gate1=0, c/t=0, Mode1=01 16-bit counter
		clr		A			reset T1 and overflowcounter
		mov		TL1,A
		mov		TH1,A
		mov		ovc1,A
		clr		TF1			clear T1 overflowbit
		clr		PT1			Timer1 priority
		
		setb		ET1			enable Timer1-Int
		setb		rcreq		round-calc request
		jb		rcreq,*		wait for round-calc ready

		mov		A,TH1		ovc1|TH1|TL1 / 256 (360/4/32/2)
		cpl		A			result is positiv, Timer
		mov		rpl,A		needs negative value
		mov		A,ovc1		store in rph|rpl
		cpl		A
		mov		rph,A

*************************************************************************

initser
        	anl		TMOD,#$0f     	T1 vorbereiten ohne T0 zu verndern
        	orl		TMOD,#$20     	Gate1=0, c/t1=0, Mode1=02 8-bit autoreload
		clr		ES			disable seriel-IR
		clr		ET1			disable T1-IR
		mov		TH1,#BAREL	baudrate relaod
		mov		TL1,TH1		startvalue
		setb		TR1			start Timer1
		orl		PCON,#$80		SMOD=1, no predivision
		mov		SCON,#$52		mode 1, async. 8 bit, sm2=0 no stopbit
*							TB8=0, RB8=0, TI=1, REN=1, RI=1
		ret

*************************************************************************

Ext0Int	
		jb		dosup,?e1i2
		jb		tsync,?e1i2	timer-sync?
		clr		TR0			no, reinit rotation-bit-control
		mov		TL0,rpl
		mov		TH0,rph
		setb		TR0			start Timer

		mov		lcl,#0		reset LED-counter
		mov		lch,#0
		setb		lstart		LED start
		
?e1i2	jnb		rcreq,?e1i9	round-calc-request?
		jb		rcact,?e1i1	yes, already active?
		setb		TR1			no, run Timer1
		setb		rcact		now active
*		setb		EX0			no sense
		sjmp		?e1i9

?e1i1	clr		TR1			yes, stop Timer1
		clr		rcact		reset flags
		clr		rcreq

?e1i9
		reti

*************************************************************************

Timer0Int
		push		PSW			save registers
		push		A
		push		?R0

		clr		TR0			reinit LED-On-Timer
		mov		TL0,rpl
		mov		TH0,rph
		setb		TR0			start Timer

		jnb		lstart,?t0i2	LED start?
		jb		ledoti,?t0i1	yes, LED-On-Time?
		mov		R0,dz1		no, get next byte of data
		mov		A,[R0]
		mov		LEDOUT,A		data output	
		setb		ledoti		LED-On-Time now
		sjmp		?t0i8

?t0i1	mov		LEDOUT,#$ff	yes, LED-On-Time
		clr		ledoti		is over now
		inc		dz1			get ready for next byte of data
		mov		A,dz1
		cjne		A,#DATA1+MAXD1,?t0i8	check for last byte
		mov		dz1,#DATA1			reinit datapointer
		clr		lstart		LED stop
		setb		dosup		double suppress on 
		sjmp		?t0i8

?t0i2	jnb		tsync,?t0i3	Timer-sync?
		mov		A,lcl		yes
		xrl		A,lcresetl	LED-counter=LCRESET?
		jnz		?t0i8 		
		mov		A,lch	
		xrl		A,lcreseth
		jnz		?t0i8		
		mov		lcl,#0		yes, reset LED-counter
		mov		lch,#0
		setb		lstart		LED start
		sjmp		?t0i9

?t0i3	mov		A,lcl		LED-counter = LCSTOP?
		xrl		A,#LCSTOP		suppress double IR-Sync	
		jnz		?t0i8
		mov		A,lch
		xrl		A,#=LCSTOP
		jnz		?t0i8		
		clr		dosup		yes,	double suppress off
		clr		TR0			stop Timer0

?t0i8	inc		lcl
		mov		A,lcl
		jnz		?t0i9
		inc		lch

?t0i9
		pop		?R0			restore registers
		pop		A
		pop		PSW
		reti

*************************************************************************

Timer1Int
		inc		ovc1			increment overflowcounter
		reti					(only if round-calc is active)

